"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const node_1 = require("./node");
describe('hasNext', function () {
    it('should be true', function () {
        let first = new node_1.Node(1);
        let second = new node_1.Node(2);
        first.next = second;
        expect(first.hasNext()).toBe(true);
    });
    it('should be false', function () {
        let first = new node_1.Node(1);
        expect(first.hasNext()).toBe(false);
        first.next = null;
        expect(first.hasNext()).toBe(false);
    });
});
describe('hasPrevious', function () {
    it('should be true', function () {
        let first = new node_1.Node(1);
        let second = new node_1.Node(2);
        first.previous = second;
        expect(first.hasPrevious()).toBe(true);
    });
    it('should be false', function () {
        let first = new node_1.Node(1);
        expect(first.hasPrevious()).toBe(false);
        first.previous = null;
        expect(first.hasPrevious()).toBe(false);
    });
});
describe('data', function () {
    it('should return 1', function () {
        let node = new node_1.Node(1);
        expect(node.data).toEqual(1);
    });
    it('should set 2', function () {
        let node = new node_1.Node(1);
        node.data = 2;
        expect(node.data).toEqual(2);
    });
});
describe('get next', function () {
    it('should return second', function () {
        let first = new node_1.Node(1);
        let second = new node_1.Node(2);
        first.next = second;
        expect(first.next).toEqual(second);
    });
});
describe('get previous', function () {
    it('should return second', function () {
        let first = new node_1.Node(1);
        let second = new node_1.Node(2);
        second.previous = first;
        expect(second.previous).toEqual(first);
    });
});
//# sourceMappingURL=node.spec.js.map