"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const stack_1 = require("./stack");
describe('stack', function () {
    it('should stack 1 element', function () {
        const stack = new stack_1.Stack();
        stack.stack(1);
        expect(stack.length()).toEqual(1);
    });
    it('should enstack 2 element', function () {
        const stack = new stack_1.Stack();
        stack.stack(1);
        stack.stack(1);
        expect(stack.length()).toEqual(2);
    });
});
describe('unstack', function () {
    it('should unstack 1 element', function () {
        const stack = new stack_1.Stack();
        stack.stack(1);
        expect(stack.unstack()).toEqual(1);
        expect(stack.length()).toEqual(0);
        stack.stack(1);
        stack.stack(2);
        expect(stack.unstack()).toEqual(2);
        expect(stack.length()).toEqual(1);
        expect(stack.unstack()).toEqual(1);
        expect(stack.length()).toEqual(0);
    });
});
describe('destack', function () {
    it('should enstack 1 element', function () {
        const stack = new stack_1.Stack();
        stack.stack(1);
        expect(stack.unstack()).toEqual(1);
    });
});
describe('empty', function () {
    it('should return false', function () {
        const queue = new stack_1.Stack();
        queue.stack(1);
        expect(queue.empty()).toBe(false);
    });
    it('should return true', function () {
        const queue = new stack_1.Stack();
        expect(queue.empty()).toBe(true);
    });
});
describe('peek', function () {
    it('should return 1', function () {
        let list = new stack_1.Stack();
        list.stack(1);
        expect(list.peek()).toEqual(1);
    });
});
//# sourceMappingURL=stack.spec.js.map