"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const no_such_property_exception_1 = require("../../exceptions/no-such-property-exception");
const reflect_1 = require("../util/reflect");
function select(selectList, from, method) {
    return selectList.map((key) => {
        let values = from[method]();
        if (!reflect_1.propertyExistsIn(values, key))
            throw new no_such_property_exception_1.NoSuchPropertyException(`The specified property "${key}" does not exist in the data provided collection`);
        return `_${key}`;
    });
}
exports.select = select;
function selectFilter(from, select) {
    from.forEach((e) => {
        Object.getOwnPropertyNames(e)
            .filter(key => !select.includes(key))
            .forEach((key) => Reflect.deleteProperty(e, key));
    });
    return from;
}
exports.selectFilter = selectFilter;
//# sourceMappingURL=select.js.map